/* animation.js */

Janice._Animation = {};
Janice._Animation.staticm = {};
Janice._Animation.method = {};


Janice._Animation.staticm.decomposeVersion = function(versionNumber) {
    var major = Math.floor(versionNumber)
    var minor = parseInt(('' + (versionNumber - major)).substr(2));

    return {
        major: major,
        minor: minor
    };
};


Janice._Animation.method.draw = function(context, t) {
    this.container.draw(context, t);
};


Janice._Animation.method.save = function() {
    var saveStr = '{';

    saveStr += '"v":' + this.version;
    saveStr += ',';
    saveStr += '"w":' + this.width;
    saveStr += ',';
    saveStr += '"h":' + this.height;
    saveStr += ',';
    saveStr += '"d":' + this.duration;
    saveStr += ',';

    saveStr += '"c":' + Janice._Container.staticm.save(this.container);

    return saveStr + '}';
};


Janice._Animation.method.load = function(data) {
    if (typeof data == 'string') {
        try {
            data = jsonParse(data);
        }
        catch (ex) {
            throw 'InvalidJsonData';
        }
    }

    // Check version:
    var thisVersion = Janice._Animation.staticm.decomposeVersion(this.version);
    var dataVersion = Janice._Animation.staticm.decomposeVersion(data.v);
    if (thisVersion.major !== dataVersion.major) {
        throw 'IncompatibleMajorVersion';
    }
    else if (thisVersion.minor < dataVersion.minor) {
        throw 'IncompatibleMinorVersion';
    }

    // Load animation settings:
    this.width = data.w;
    this.height = data.h;
    this.duration = data.d;

    // Load contents:
    this.container = Janice._Container.staticm.load(data.c);
};


Janice.Animation = function(duration) {
    var animation = {};
    animation.version = 0.1;

    animation.width = 480;
    animation.height = 320;

    animation.duration = duration ? parseInt(duration) : 5000; // In milliseconds.

    animation.container = Janice.Container();
    animation.draw = Janice._Animation.method.draw;

    animation.save = Janice._Animation.method.save;
    animation.load = Janice._Animation.method.load;

    return animation;
};

