/* container.js */


Janice._Container = {};
Janice._Container.staticm = {};
Janice._Container.method = {};


Janice._Container.method.draw = function(context, propertyValues, t) {
    for (var i = 0; i < this._drawOrder.length; ++i) {
        var id = this._drawOrder[i];
        this._objects[id].draw(context, t);
    }
};


Janice._Container.method.addObject = function(object) {
    var id = '' + (this._nextId++);
    this._objects[id] = object;
    this._drawOrder.push(id);
};


Janice._Container.staticm.Blueprint = {
    draw: Janice._Container.method.draw,
    properties: {},
    type: 'container'
};


Janice._Container.staticm.convertAnimObjectToContainer = function(object) {
    object._drawOrder = [];
    object._objects = {};
    object._nextId = 1;
    object.addObject = Janice._Container.method.addObject;
};


Janice._Container.staticm.save = function(container) {
    var extraData = '"o":[';
    var firstObject = true;
    for (var i = 0; i < container._drawOrder.length; ++i) {
        if (firstObject) { firstObject = false; } else { extraData += ','; }
        var id = container._drawOrder[i];
        var object = container._objects[id];
        if (object.type == 'container') {
            extraData += Janice._Container.staticm.save(object);
        }
        else {
            extraData += Janice._AnimObject.staticm.save(object);
        }
    }
    extraData += ']';

    return Janice._AnimObject.staticm.save(container, extraData);
};


Janice._Container.staticm.load = function(data) {
    var container = Janice._AnimObject.staticm.load(data, Janice._Container.staticm.Blueprint);

    Janice._Container.staticm.convertAnimObjectToContainer(container);

    for (var i = 0; i < data.o.length; ++i) {
        var objectData = data.o[i];
        container.addObject(objectData.t == 'container' ?
            Janice._Container.staticm.load(objectData, Janice._Container.staticm.Blueprint) :
            Janice._AnimObject.staticm.load(objectData));
    }

    return container;
};


Janice.Container = function(overrideProperties) {
    var container = Janice.AnimObject(Janice._Container.staticm.Blueprint, overrideProperties);

    Janice._Container.staticm.convertAnimObjectToContainer(container);

    return container;
};

