/* propertytype.js */


Janice._Color = {};
Janice._Color.method = {};
Janice._Color.staticm = {};


Janice.Color = function(r, g, b) {
    return {
        r: r,
        g: g,
        b: b,
        toHexString: Janice._Color.method.toHexString
    };
};


Janice._Color.method.toHexString = function() {
    return (16777216 + this.r * 65536 + this.g * 256 + this.b).toString(16).substr(1);
};


Janice._Color.staticm.fromHexString = function(str) {
    return Janice.Color(
        parseInt(str.substr(0, 2), 16),
        parseInt(str.substr(2, 2), 16),
        parseInt(str.substr(4, 2), 16)
    );
};


Janice.PropertyTypes = {
    number: {
        interpolate: function(oldValue, newValue, i) {
            return oldValue + (i * (newValue - oldValue));
        },
        toString: function(value) { return '' + value; },
        fromString: function(str) { return parseFloat(str); }
    },
    bool: {
        interpolate: function(oldValue, newValue, i) {
            return i < 0.5 ? oldValue : newValue;
        },
        toString: function(value) { return value ? '1' : '0'; },
        fromString: function(str) { return parseInt(str) ? true : false; }
    },
    string: {
        interpolate: function(oldValue, newValue, i) {
            return typeof newValue == 'function' ? newValue(i) :
                i < 0.5 ?
                    (typeof oldValue == 'function' ? oldValue(1) : oldValue) :
                    newValue;
        },
        toString: function(value) {
            if (typeof value == 'function') {
                //throw 'DontKnowHowToSerializeFunctions'; // TODO: What to do here?
                return 'FUNCTION';
            }
            else {
                return value;
            }
        },
        fromString: function(str) { return str; }
    },
    color: {
        interpolate: function(oldValue, newValue, i) {
            return Janice.Color(
                Math.round(oldValue.r + (i * (newValue.r - oldValue.r))),
                Math.round(oldValue.g + (i * (newValue.g - oldValue.g))),
                Math.round(oldValue.b + (i * (newValue.b - oldValue.b)))
            );
        },
        toString: function(value) { return value.toHexString(); },
        fromString: function(str) { return Janice._Color.staticm.fromHexString(str); }
    },
};

