
function createAnimation() {
    var anim = Janice.Animation(5000);

    var text1 = Janice.AnimObject('text', { x: 240, y: 160, scale: 90, text: 'Hello world!' });
    text1.addModification('scale', Janice.Transition(1000, 4000), 3);
    text1.addModification('rotation', Janice.Transition(1000, 4500), -720);
    anim.container.addObject(text1);

    var rect = Janice.AnimObject('rectangle', { x: 180, y: 100, height: 160,
            color: Janice.Color(0, 255, 255) });
    anim.container.addObject(rect);
    rect.setPropertyValue('width', 220);

    var tr1 = Janice.Transition(1000, 2500, 'quadratic', true);
    rect.addModification('x', tr1, 400);
    rect.addModification('height', tr1, 40);

    rect.addModification('color', Janice.Switch(2500), Janice.Color(0, 255, 0));

    var tr2 = Janice.Transition(3000, 4500, 'linear', true);
    rect.addModification('x', tr2, 300);
    rect.addModification('y', tr2, 240);
    rect.addModification('scale', tr2, 2);
    rect.addModification('rotation', tr2, 180);

    rect.addModification('color', Janice.Transition(4500, 5000), Janice.Color(255, 0, 255));

    rect.addModification('show', Janice.Switch(3500), false);
    rect.addModification('show', Janice.Switch(4000), true);

    var text2 = Janice.AnimObject('text', { x: 240, y: 300, text: 'Start', color: Janice.Color(0, 127, 0) });
    text2.addModification('text', Janice.Transition(0, 5000), function(i) {
        return '' + Math.floor(100 * i) + '% complete';
    });
    anim.container.addObject(text2);

    return anim;
}


function test() {
    var anim1 = createAnimation();
    var data1 = anim1.save();
    var anim2 = Janice.Animation();
    print(data1);
    anim2.load(data1);
    var data2 = anim2.save();

    var result = data1 === data2;

    return true;
}


